function [y, wout, convergedFlag] = cICAM(X, t, threshold, w0, learningRate, mu0, lambda0, gamma, maxIter, OverValue)
% Constrained ICA for extracting one source signal using the reference signal.
%
% Command:
%   [y, w] = cICA(X, ref, threshold, w0, learningRate, mu0, lambda0, gamma, maxIter, OverValue)??
%
% Parameters:
%            y --- extracted source signal, according to the given optimal time delay.
%            w --- corresponding weight vector, that is, y=w'*X.
%            X --- prewhitened observed mixed signals. Each row is a mixed signal.
%          ref --- reference signal, which can be generated by function genRectangleRef
%                  and genPulseRef
%    threshold --- the closeness of the desired signal and the reference signal is less than
%                  or equal to the threshold, i.e., closeness(y,ref) - threshold <= 0
%           w0 --- the initial weight vector
% learningRate --- learning rate of the weight w
%          mu0 --- the Lagrange multiplier for constraint g(w)
%      lambda0 --- the Lagrange multiplier for constraint h(w)
%        gamma --- the scalar penalty parameter
%  OverValue --- stopping criterion, say, 0.0001. When the changed value
%                of weighted vector is less than it, then the algorithm stops
%    maxIter --- maximum iterations for estimating each independent component
%
% See also:
%    genPulseRef     genRectangleRef     cICAdemo
%
% Reference:
%    [1] Wei Lu, Jagath C. Rajapakse: ICA with reference. ICA 2001
%    [2] Zhi-Lin Zhang, Morphologically Constrained ICA for Extracting Weak Temporally
%        Correlated Signals, Neurocomputing 71(7-9) (2008) 1669-1679
%
% Author: Zhilin Zhang
%         z4zhang@ucsd.edu
%
% version: 1.0     Date: Dec.14,2008
%


fprintf('Starting cICA for extracting the desired source signal ..\n');
[ICnum, IClen]=size(X);
if isstruct(w0)
    w=w0.w;
else
    w = w0;
end
%w=w/norm(w);
oldw = w;

mu = mu0;
lambda = lambda0;

convergedFlag = 1;
loop = 1;

addpath('../tools/FastICA');
firstEig=1;
lastEig=ICnum;
interactivePCA='off';
verbose='on';
[E, D]=pcamat(X, firstEig, lastEig, interactivePCA, verbose);
% Calculate the whitening
[whitesig, whiteningMatrix, dewhiteningMatrix] = whitenv(X, E, D, verbose);
X=whitesig;
if size(X,1)==1
    wout=w0;
    y=X;
    convergedFlag=0;
    return;
end
w=whiteningMatrix*w;
w=w/norm(w);
oldw=w;
% if size(X,1)<ICnum
%     %Dimensions are reduced, adjust w
%     fprintf(2,'Dimensions reduced!\n');
%     if isstruct(w0)
%         w=w0.w2;
%         w0.dimRedWinInds=[w0.dimRedWinInds winIndex];
%        
%     else
%         w = rand(size(X,1),1);w=w/norm(w);
%     end
%     oldw = w;
% end

% compute the autocorrelation matrix Rxx
Rxx = X(:,1:end) * X(:,1:end)' / IClen;

%Plot W plane
%f=figure(8);
%
%subplot(2,2,2);
%x=-2:.5:2;
%[x,y] = meshgrid(x);
%      f(x,y) = p00 + p10*x + p01*y
% Coefficients (with 95% confidence bounds):
% p00 =     0.01965  ;
% p10 =     -0.8677  ;
% p01 =     -0.8712  ;
% Z=p00 + p10*x + p01*y;
% surf(x,y,Z);
% shading flat;
% xlabel('x'); ylabel('y'); zlabel('z')
% view(65,20);

%W constraints
%  c2=[0 1 -1];
%  c3=[-1 1 0];
%  tw=.2; 
% mu2=1; mu3=1;
while (convergedFlag == 1)
    
    % output at current iteration
    y = w' * X;
    
    % calculate the first order deviation of the Lagarange function
    std_y = std(y);                          % standard deviation
    v_Gaus = normrnd(0, std_y, 1, IClen);    % Gaussian signal with the same mean and variance
    rou = mean( log(cosh(y)) - log(cosh(v_Gaus)) );
%     objf=tanh(y) - tanh(v_Gaus);
%     rou = mean( objf );
    rous(loop)=rou;
    %figure(7);cla;
    %[Ggt,g1gt,g2gt]=autocorrd(gt,t);
    [G,g1,g2]=autocorrd(y,X,1/mean(diff(t)));
    % test
%     G(1:round(0.7*30))=0;
%     G(3*30:end)=0;
%     g1(1:round(0.7*30))=0;
%     g1(3*30:end)=0;
%     g2(1:round(0.7*30))=0;
%     g2(3*30:end)=0;
    
    Gmean=mean(G.*G);
    Gmeans(loop)=Gmean;
    %figure(8);
    %subplot(2,2,1);
    %hold on
    %quiver3(0,0,0,w(1),w(2),w(3));
    %plot(G);
    %title('G');
    %quiver3(0,0,0,w(1),w(2),0);
    %pause(.001)
    %subplot(2,2,2);
    %cla
%     hold on
%     scatter(loop,rou,'x');
%     title('objf');
%     subplot(2,2,4);
%     hold on
%     scatter(loop,Gmean,'x');
%     title('Mean(G^2)');
%     pause(.001);
    %title('Mean(G)');
    %hold on;
    %plot(g1);
    %plot(G);
    %[mean(abs(G)) mean(abs(g1)) mean(abs(g2))]
    % plot(Ggt);
    
    %objf=mean(( X * tanh(y)'));
%      L1 = sign(rou) * ( X * tanh(y)')/IClen -  mu * (g1) ...
%          - lambda * ( X * y')/IClen;          %Eqn 15
%     L1 = sign(rou) * ( X * (sech(y).^2)')/IClen -  mu * (g1) ...
%         - lambda * ( X * y')/IClen;          %Eqn 15

L1 = sign(rou) * ( X * tanh(y)')/IClen - mu *   (g1) ...
         - lambda * ( X * y')/IClen;          %Eqn 15
     
    %L1 = sign(rou) * ( X * (sech(y).^2)')/IClen
    % related to the second order deviation of the Lagarange function
    %g2 already contains the expectation computation
    %Sw = sign(rou) * mean(1-tanh(y).^2)*Rxx - mu*g2 - lambda*Rxx;
%     Sw = sign(rou) * Rxx*(mean(1-tanh(y).^2)) - Rxx*lambda- mu*(g2);
    %Sw = sign(rou) * mean(-2*sech(y).^2.*tanh(y))*Rxx - mu*(g2) -lambda*Rxx;
    
    Sw = sign(rou) * Rxx*(mean(1-tanh(y).^2)) - Rxx*lambda -mu * (g2);
    
    % update of the weight vector
    
    %  w = w - learningRate\(Rxx) * L1 / Sw;   %Eqn 17
    w = w - learningRate\(Sw)* L1;   %Eqn 17
    %w2 = w - learningRate*inv(Sw)*L1;
    %     w = w - learningRate * L1 / Sw;
    w = w/norm(w);
    
    W=dewhiteningMatrix*w;
    % update of the parameter mu
    %thr = threshold * (1-exp(-loop));            %Eqn 18
    thr = threshold;
    %g = mean( (y-ref).^2 ) - thr;    % corresponds to the inequality constraint
    %g=mean(G)-thr;
    %g=thr-Gmean;
    g=rou-thr;
    mu=min(mu + gamma * g);
    if g>0
        gamma=.5*gamma;
    end
%     if loop==1
%         mu = max(0, mu + gamma * g);
%     else
%         mu = max(mus(loop-1), mu + gamma * g);
%     end
    mus(loop)=mu;
    
%     g2=tw-c2*w;             g3=tw-c3*w;
%     mu2=mu2 + gamma * g2;   mu3=mu3 + gamma * g3;
    
    %     if mu==0
    %         mu = max(0, mu + gamma * g);
    %     end
    mus(loop)=mu;
    %mu = mu + gamma * g
    % update of the parameter lambda
    h = mean(y.^2) - 1;                    % corresponds to the equality constraint
    lambda = lambda + gamma * h;                 %Eqn 19
    
    % decide whether the algorithm has converged or not
    wchange = 1-abs(w'*oldw);
    fprintf('No.%d iteration: change in w is %g\n',loop, wchange);
    if wchange < OverValue
        fprintf('Converged after %d iteration, Gmean= %f \n',loop, Gmean);
        convergedFlag = 0;
    end
    
    if loop >= maxIter
        %fprintf('After %d iteration, still cannot convergent.\n',loop);
        convergedFlag = 2;
    end
    
    oldw = w;
    loop = loop + 1;
    
end

%w=[0.8541   -0.7340   -0.0121];
% % output
% figure(8);
% subplot(2,2,1);
% plot(Gmeans,'-x'); title('E\{G^2\}');
% subplot(2,2,2);
% plot(mus,'-x'); title('\mu');
% subplot(2,2,3);
% plot(rous,'-x'); title('\rho');
y = w'* X;

%y=W'*X;
if isstruct(w0)
    %Check if dimension was reduced and save the new w for the next
    %window
    w0.w=W;
    wout=w0;
else
    wout=W;
end
%close all
%plot(mus);
%fprintf('End of cICA algorithm !\n');
